/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./wp-content/plugins/voicer/source/js/import/_audioContext.js":
/*!*********************************************************************!*\
  !*** ./wp-content/plugins/voicer/source/js/import/_audioContext.js ***!
  \*********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   stopActiveSource: () => (/* binding */ stopActiveSource),
/* harmony export */   webAudioUnlock: () => (/* binding */ webAudioUnlock)
/* harmony export */ });
/**
 * Unlock browser audio context
 */
function webAudioUnlock() {

    let AudioContext = window.AudioContext || window.webkitAudioContext || false;
    window.mdpVoicerContext = new AudioContext();

    window.mdpVoicerContext.resume();

}

/**
 * Stop active source
 */
function stopActiveSource() {

    if (window.voicerActiveSource) {

        window.voicerActiveSource.onended = null; // manual stop, no event
        window.voicerActiveSource.stop(0);

    }

}


/***/ }),

/***/ "./wp-content/plugins/voicer/source/js/import/_icons.js":
/*!**************************************************************!*\
  !*** ./wp-content/plugins/voicer/source/js/import/_icons.js ***!
  \**************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   setPlayIcon: () => (/* binding */ setPlayIcon),
/* harmony export */   setPreloaderIcon: () => (/* binding */ setPreloaderIcon)
/* harmony export */ });
const { playIcon } = window.mdpVoicer;

/** Set Play Icon . */
function setPlayIcon( uid = '' ) {

    /** Select old icon that will be replaced. */
    const el = uid !== '' ?
        document.querySelector( `#mdp-voicer-${ uid } div.mdp-voicer-btn` ) :
        document.querySelector( `.mdp-voicer div.mdp-voicer-btn` );

    /** Create a new icon that will take the place of "el". */
    const newEl = document.createElement('div');
    newEl.classList.add( 'mdp-voicer-btn' );
    newEl.innerHTML = playIcon;

    /** Replace el with newEL. */
    el.parentNode.replaceChild( newEl, el );

    /** Mark tooltip as 'Play' button. */
    const stop_popup = document.querySelector('.mdp-voicer');
    stop_popup.classList.remove( 'stop' );
    stop_popup.classList.remove( 'loading' );

}

/** Set Preloader Icon . */
function setPreloaderIcon( uid ) {

    /** Select old icon that will be replaced. */
    const el = document.querySelector( `#mdp-voicer-${ uid } div.mdp-voicer-btn` );
    const preloaderIcon = '<svg id="mdp-voicer-preloader" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" width="512" height="512"><rect x="3" y="7" rx="2" ry="2" width="4" height="10"><animate attributeName="y" calcMode="spline" values="7;9;7" keyTimes="0;0.5;1" dur="0.6" keySplines="0 0.5 0.5 1;0 0.5 0.5 1" begin="0" repeatCount="indefinite"/><animate attributeName="height" calcMode="spline" values="10;6;10" keyTimes="0;0.5;1" dur="0.6" keySplines="0 0.5 0.5 1;0 0.5 0.5 1" begin="0" repeatCount="indefinite"/></rect><rect x="8" y="2" rx="2" ry="2" width="4" height="20"><animate attributeName="y" calcMode="spline" values="2;4;2" keyTimes="0;0.5;1" dur="0.5" keySplines="0 0.5 0.5 1;0 0.5 0.5 1" begin="0" repeatCount="indefinite"/><animate attributeName="height" calcMode="spline" values="20;16;20" keyTimes="0;0.5;1" dur="0.5" keySplines="0 0.5 0.5 1;0 0.5 0.5 1" begin="0" repeatCount="indefinite"/></rect><rect x="13" y="4" rx="2" ry="2" width="4" height="16"><animate attributeName="y" calcMode="spline" values="4;7;4" keyTimes="0;0.5;1" dur="0.7" keySplines="0 0.5 0.5 1;0 0.5 0.5 1" begin="0" repeatCount="indefinite"/><animate attributeName="height" calcMode="spline" values="16;10;16" keyTimes="0;0.5;1" dur="0.7" keySplines="0 0.5 0.5 1;0 0.5 0.5 1" begin="0" repeatCount="indefinite"/></rect><rect x="18" y="8" rx="2" ry="2" width="4" height="8"><animate attributeName="y" calcMode="spline" values="8;10;8" keyTimes="0;0.5;1" dur="0.8" keySplines="0 0.5 0.5 1;0 0.5 0.5 1" begin="0" repeatCount="indefinite"/><animate attributeName="height" calcMode="spline" values="8;4;8" keyTimes="0;0.5;1" dur="0.8" keySplines="0 0.5 0.5 1;0 0.5 0.5 1" begin="0" repeatCount="indefinite"/></rect></svg>';

    /** Create a new icon that will take the place of "el". */
    const newEl = document.createElement('div');
    newEl.classList.add( 'mdp-voicer-btn' );
    newEl.innerHTML = preloaderIcon;

    /** Replace el with newEL. */
    el.parentNode.replaceChild( newEl, el );

    /** Mark tooltip as 'Stop' button. */
    const stop_popup = document.querySelector( `#mdp-voicer-${ uid }` );
    stop_popup.classList.remove( 'stop' );
    stop_popup.classList.add( 'loading' );

}


/***/ }),

/***/ "./wp-content/plugins/voicer/source/js/import/_init.js":
/*!*************************************************************!*\
  !*** ./wp-content/plugins/voicer/source/js/import/_init.js ***!
  \*************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   loadVoicer: () => (/* binding */ loadVoicer)
/* harmony export */ });
/* harmony import */ var _audioContext__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./_audioContext */ "./wp-content/plugins/voicer/source/js/import/_audioContext.js");
/* harmony import */ var _textSelection__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_textSelection */ "./wp-content/plugins/voicer/source/js/import/_textSelection.js");
/* harmony import */ var _mouseOver__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./_mouseOver */ "./wp-content/plugins/voicer/source/js/import/_mouseOver.js");




function loadVoicer() {

    if ( ! window.mdpVoicer ) { return; }
    window.voicerActiveSource = null;

    /**
     * Unlock AudioContext
     */
    if ( window.mdpVoicer.onSelect || window.mdpVoicer.onHover ) {

        document.body.addEventListener( 'click', _audioContext__WEBPACK_IMPORTED_MODULE_0__.webAudioUnlock, false );

    }

    /**
     * Init voicing by text select
     */
    if ( window.mdpVoicer.onSelect ) {

        const voicerSelection = new _textSelection__WEBPACK_IMPORTED_MODULE_1__.VoicerSelection();
        voicerSelection.init();

        window.mdpVoicer.highlight = voicerSelection;

    }

    /**
     * Init voicing by hover
     */
    if ( window.mdpVoicer.onHover ) {

        document.body.addEventListener( 'mouseover', _mouseOver__WEBPACK_IMPORTED_MODULE_2__.mouseOver );

    }

}


/***/ }),

/***/ "./wp-content/plugins/voicer/source/js/import/_mouseOver.js":
/*!******************************************************************!*\
  !*** ./wp-content/plugins/voicer/source/js/import/_mouseOver.js ***!
  \******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   mouseOver: () => (/* binding */ mouseOver)
/* harmony export */ });
/* harmony import */ var _audioContext__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./_audioContext */ "./wp-content/plugins/voicer/source/js/import/_audioContext.js");


function mouseOver( e ) {

    window.mdpVoicer.lastHovered = e.target;
    clearTimeout( window.mdpVoicer.hoverTimeout );
    const { ajaxurl, nonce, onHover, hoverDelay } = mdpVoicer;
    const voicingTriggers = document.querySelectorAll( onHover );

    voicingTriggers.forEach( $el => {

        let text = '';
        let lang = '';
        let voice = '';

        if ( $el === e.target ) {

            // TODO: exclude screen-reader-text
            // https://make.wordpress.org/accessibility/handbook/markup/the-css-class-screen-reader-text/
            text = e.target.innerText;

            if ( window.mdpVoicer.lastVoiced && text === window.mdpVoicer.lastVoiced ) { return; }

            window.mdpVoicer.hoverTimeout = setTimeout( function () {

                if ( window.mdpVoicer.lastHovered !== e.target ) { return; } // Don`t voicing anything if hover changed

                /** Change cursor */
                if ( ! window.mdpVoicerContext ) {
                    changeCursor( 'help' );
                    return false;
                } else {
                    changeCursor( 'wait' );
                }

                /** AJAX Request with vanilla JS. */
                const request = new XMLHttpRequest();

                /** Get language code from html tag or paragraph class*/
                lang = lang.length === 0 ? document.documentElement.lang : lang;

                request.open( 'POST', ajaxurl, true );
                request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
                request.onload = function () {

                    /** If successful. */
                    if ( this.status >= 200 && this.status < 400 ) {

                        if ( ! AudioContext ) {
                            console.error( 'Error of creating AudioContext.' );
                            changeCursor();
                            return;
                        }

                        window.mdpVoicerContext.decodeAudioData( this.response, function( buffer ) {
                            const source = window.mdpVoicerContext.createBufferSource();
                            source.buffer = buffer;
                            (0,_audioContext__WEBPACK_IMPORTED_MODULE_0__.stopActiveSource)(); // Stop the active one if any.
                            window.voicerActiveSource = source;
                            source.connect( window.mdpVoicerContext.destination );
                            source.onended = changeCursor;
                            source.start( 0 );

                            changeCursor( 'progress' );
                            window.mdpVoicer.lastVoiced = '';

                        }, function( e ){
                            console.error( 'Error of decoding audio data' + e.err );
                            changeCursor();
                        });

                    } else {

                        console.warn( `Fail request: ${ this.response }` );
                        changeCursor();

                    }

                };
                request.onerror = function() {

                    console.warn( 'Connection error.' );
                    changeCursor();

                };
                request.responseType = 'arraybuffer';
                request.send( `action=voicer_gspeak&nonce=${ nonce }&text=${ encodeURIComponent( text ) }&lang=${ lang }&voice=${ voice }` );

                window.mdpVoicer.lastVoiced = text;
                window.mdpVoicer.lastHovered = '';

            }, hoverDelay );

        }

        /** Change cursor during playback */
        function changeCursor( cursor = false ) {

            ( typeof cursor !== 'string' ) ?
                $el.style.removeProperty( 'cursor' ):
                $el.style.cursor = cursor;

        }

    });

}


/***/ }),

/***/ "./wp-content/plugins/voicer/source/js/import/_perfect-selection.js":
/*!**************************************************************************!*\
  !*** ./wp-content/plugins/voicer/source/js/import/_perfect-selection.js ***!
  \**************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   getHTMLOfSelection: () => (/* binding */ getHTMLOfSelection),
/* harmony export */   selectionExceptions: () => (/* binding */ selectionExceptions),
/* harmony export */   snapSelectionToWord: () => (/* binding */ snapSelectionToWord)
/* harmony export */ });
/* harmony import */ var _textSelection__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./_textSelection */ "./wp-content/plugins/voicer/source/js/import/_textSelection.js");


/**
 * Selecting the full word if only its parts are selected
 * @return {Selection|{isCollapsed}}
 */
function snapSelectionToWord() {

    let sel;

    /** Do not Modify Selection for Touch devices. */
    if (_textSelection__WEBPACK_IMPORTED_MODULE_0__.isTouch) {

        if (window.getSelection) {

            sel = window.getSelection();

        } else if (document.getSelection) {

            sel = document.getSelection();

        } else if (document.selection) {

            sel = document.selection.createRange().text;

        }
        return sel;

    }

    /**
     * Check for existence of window.getSelection() and that it has a
     * modify() method. IE 9 has both selection APIs but no modify() method.
     **/
    if (window.getSelection && (sel = window.getSelection()).modify) {

        sel = window.getSelection();

        if (!sel.isCollapsed) {

            /** Detect if selection is backwards. */
            const range = document.createRange();
            range.setStart(sel.anchorNode, sel.anchorOffset);
            range.setEnd(sel.focusNode, sel.focusOffset);
            const backwards = range.collapsed;
            range.detach();

            /** Modify() works on the focus of the selection. */
            const endNode = sel.focusNode, endOffset = sel.focusOffset;
            sel.collapse(sel.anchorNode, sel.anchorOffset);

            let direction = backwards ?
                ['backward', 'forward'] :
                ['forward', 'backward'];

            sel.modify('move', direction[0], 'character');
            sel.modify('move', direction[1], 'word');
            sel.extend(endNode, endOffset);
            sel.modify('extend', direction[1], 'character');
            sel.modify('extend', direction[0], 'word');

        }

    } else if ((sel = document.selection) && sel.type !== 'Control') {

        const textRange = sel.createRange();

        if (textRange.text) {

            textRange.expand('word');

            /** Move the end back to not include the word's trailing space(s), if necessary. */
            while (/\s$/.test(textRange.text)) {

                textRange.moveEnd('character', -1);

            }
            textRange.select();

        }

    }

    return sel;

}

/**
 * Remove some text from voicing
 *
 * @param text
 * @returns {*}
 */
function selectionExceptions( text ) {

    // Remove all not included in voicer-voice if voicer voice exist on the page
    if ( /<\/?[a-z][\s\S]*>/i.test( text ) ) {

        // Get all tags with class and content inside tags wrap
        const stringByTags = [ ...text.matchAll( /<[a-z][^>]+>+(.?)+<\/[a-z]>/g ) ];

        for ( const htmlContent of stringByTags ) {

            if ( htmlContent[ 0 ].includes( 'voicer-voice-' ) ) {

                // Content wrapped in tags without html tags
                text = htmlContent[ 0 ].replace( /(<([^>]+)>)/ig, '' );
                break;

            }

        }

    }

    return text;

}

/**
 * Return HTML of selected text
 * @return {string|*}
 */
function getHTMLOfSelection () {

    let range;

    if ( document.selection && document.selection.createRange ) {

        range = document.selection.createRange();
        return range.htmlText;

    } else if ( window.getSelection ) {

        const selection = window.getSelection();

        if ( selection.rangeCount > 0 ) {

            range = selection.getRangeAt(0);
            const clonedSelection = range.cloneContents();
            const div = document.createElement('div');
            div.appendChild(clonedSelection);
            return div.innerHTML;

        } else {

            return '';

        }

    } else {

        return '';

    }

}


/***/ }),

/***/ "./wp-content/plugins/voicer/source/js/import/_query.js":
/*!**************************************************************!*\
  !*** ./wp-content/plugins/voicer/source/js/import/_query.js ***!
  \**************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   getArgs: () => (/* binding */ getArgs),
/* harmony export */   getQueryString: () => (/* binding */ getQueryString)
/* harmony export */ });
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./_utils */ "./wp-content/plugins/voicer/source/js/import/_utils.js");


const { nonce } = window.mdpVoicer;

/**
 * Returns args for query
 * @param uid
 * @param lang
 * @param voice
 * @param text
 * @returns {{voice: boolean, text: string | any, lang: (string|*), nonce: *}}
 */
function getArgs( uid, lang, voice, text ) {

    let theLang = lang.length === 0 ? document.documentElement.lang : lang;
    let theVoice = voice;
    let theText = text;

    /** Get text from highlighted span */
    const $highlighted = document.querySelector( `#voicer-highlight-${ uid }` );
    if ( $highlighted ) {

        let highlightedVoice = (0,_utils__WEBPACK_IMPORTED_MODULE_0__.getVoiceFromHighlight)( $highlighted );

        if ( highlightedVoice.length > 0 ) {

            theVoice = highlightedVoice;

        }

        if ( theVoice.length > 0 ) {

            theLang = highlightedVoice.split( '-', 2 ).join( '-' );

        }

        theText = $highlighted.innerHTML;

    }

    /** Leave voice blank if it's not valid */
    const voiceRegex = /\w+-\w+-\w+-[A-Z]/g;
    if ( ! theVoice.match( voiceRegex ) ) {
        theVoice = '';
    }

    return {
        lang: theLang,
        voice: theVoice,
        text: theText,
        nonce: nonce
    }

}

/**
 * Returns query string from args
 * @param args
 * @returns {string}
 */
function getQueryString( args ) {

    return Object.keys( args ).map( key => {

        return `${ key }=${ encodeURIComponent( args[ key ] ) }`;

    }).join( '&' );

}


/***/ }),

/***/ "./wp-content/plugins/voicer/source/js/import/_style.js":
/*!**************************************************************!*\
  !*** ./wp-content/plugins/voicer/source/js/import/_style.js ***!
  \**************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   addVoicerStyle: () => (/* binding */ addVoicerStyle),
/* harmony export */   removeVoicerStyle: () => (/* binding */ removeVoicerStyle)
/* harmony export */ });
/* harmony import */ var _textSelection__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./_textSelection */ "./wp-content/plugins/voicer/source/js/import/_textSelection.js");


const { radius, iconSize, iconMargin, arrowSize, bgColor, iconColor } = window.mdpVoicer;

/**
 * Add to the page <style> tag with come styles
 */
function addVoicerStyle( uid = '' ) {

    const doubleMargin = 2 * parseInt( iconMargin );
    const style = document.createElement( 'style' );
    style.setAttribute( `data-voicer`, uid );
    style.innerHTML = `           
            #mdp-voicer-${ uid } {
                background-color: ${ bgColor };
                border-radius: ${ radius }px;
                top: ${ _textSelection__WEBPACK_IMPORTED_MODULE_0__.top }px;
                left: ${ _textSelection__WEBPACK_IMPORTED_MODULE_0__.left }px;
            }
            ${ arrowDirection( uid ) }
            #mdp-voicer-${ uid } svg { 
                fill: ${ iconColor };
                max-width: ${ iconSize }px; 
                max-height: ${ iconSize }px;
                width: ${ iconSize }px; 
                height: ${ iconSize }px;
            }
            .mdp-voicer-btn {
                width: ${ parseInt( iconSize ) + doubleMargin }px;
                height: ${ parseInt( iconSize ) + doubleMargin }px;
                border-radius: ${ radius }px;
            }`;

    document.body.appendChild( style );

}

/**
 * Remove voicer <style> tag
 */
function removeVoicerStyle( id ) {

    const style = document.querySelector( `style[data-voicer="${ id }"]` );
    style.remove();

}

/**
 * Custom CSS arrow size
 * @param uid
 * @returns {string}
 */
function arrowDirection( uid = '' ) {

    let buttonSize = parseInt( iconSize ) + parseInt( iconMargin ) * 2;

    if ( uid === '' ) {

        return `
                #mdp-voicer-${ uid }:after {
                    border-left: ${ arrowSize }px solid transparent;
                    border-right: ${ arrowSize }px solid transparent;
                    border-top: ${ arrowSize }px solid ${ bgColor };
                    bottom: -${ arrowSize - 1 }px;
                    left: ${ buttonSize * _textSelection__WEBPACK_IMPORTED_MODULE_0__._icons.length / 2 - arrowSize }px;
                }`

    } else {

        const $content = document.querySelector( `#voicer-highlight-${ uid }` )
        const shortcodePosition = $content.getAttribute( 'data-position' ).split('-');

        switch ( shortcodePosition[ 0 ] ) {

            case 'top':
                return `
                #mdp-voicer-${ uid }:after {
                    border-left: ${ arrowSize }px solid transparent;
                    border-right: ${ arrowSize }px solid transparent;
                    border-top: ${ arrowSize }px solid ${ bgColor };
                    bottom: -${ arrowSize - 1 }px;
                    left: ${ buttonSize * _textSelection__WEBPACK_IMPORTED_MODULE_0__._icons.length / 2 - arrowSize }px;
                }`;

            case 'left':
                return `
                #mdp-voicer-${ uid }:after {
                    border-top: ${ arrowSize }px solid transparent;
                    border-bottom: ${ arrowSize }px solid transparent;
                    border-left: ${ arrowSize }px solid ${ bgColor };
                    top: ${ buttonSize / 2 - arrowSize }px;
                    left: ${ buttonSize - 1 }px;
                }`;

            case 'right':
                return `
                #mdp-voicer-${ uid }:after {
                    border-top: ${ arrowSize }px solid transparent;
                    border-bottom: ${ arrowSize }px solid transparent;
                    border-right: ${ arrowSize }px solid ${ bgColor };
                    top: ${ buttonSize / 2 - arrowSize }px;
                    left: ${ 1 - arrowSize }px;
                }`;

            case 'bottom':
                return `
                #mdp-voicer-${ uid }:after {
                    border-left: ${ arrowSize }px solid transparent;
                    border-right: ${ arrowSize }px solid transparent;
                    border-bottom: ${ arrowSize }px solid ${ bgColor };
                    top: -${ arrowSize - 1 }px;
                    left: ${ buttonSize * _textSelection__WEBPACK_IMPORTED_MODULE_0__._icons.length / 2 - arrowSize }px;
                }`;

            default:
                return `
                #mdp-voicer-${ uid }:after {
                    border-left: ${ arrowSize }px solid transparent;
                    border-right: ${ arrowSize }px solid transparent;
                    border-top: ${ arrowSize }px solid ${ bgColor };
                    bottom: -${ arrowSize - 1 }px;
                    left: ${ buttonSize * _textSelection__WEBPACK_IMPORTED_MODULE_0__._icons.length / 2 - arrowSize }px;
                }`;

        }

    }

}


/***/ }),

/***/ "./wp-content/plugins/voicer/source/js/import/_textSelection.js":
/*!**********************************************************************!*\
  !*** ./wp-content/plugins/voicer/source/js/import/_textSelection.js ***!
  \**********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   VoicerSelection: () => (/* binding */ VoicerSelection),
/* harmony export */   _icons: () => (/* binding */ _icons),
/* harmony export */   isTouch: () => (/* binding */ isTouch),
/* harmony export */   left: () => (/* binding */ left),
/* harmony export */   selection: () => (/* binding */ selection),
/* harmony export */   top: () => (/* binding */ top)
/* harmony export */ });
/* harmony import */ var _audioContext__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./_audioContext */ "./wp-content/plugins/voicer/source/js/import/_audioContext.js");
/* harmony import */ var _style__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_style */ "./wp-content/plugins/voicer/source/js/import/_style.js");
/* harmony import */ var _tooltip_position__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./_tooltip-position */ "./wp-content/plugins/voicer/source/js/import/_tooltip-position.js");
/* harmony import */ var _perfect_selection__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./_perfect-selection */ "./wp-content/plugins/voicer/source/js/import/_perfect-selection.js");
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./_utils */ "./wp-content/plugins/voicer/source/js/import/_utils.js");
/* harmony import */ var _query__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./_query */ "./wp-content/plugins/voicer/source/js/import/_query.js");
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./_icons */ "./wp-content/plugins/voicer/source/js/import/_icons.js");
/**
 * @param window.mdpVoicer
 * @type {function(): {init: function(): init, config: function(*): config}}
 */








let _icons = {};
let top = 0;
let left = 0;
let isTouch = false; //Detect touch device
let selection = '';

const VoicerSelection = ( () => {

    "use strict";

    /** Get options from WordPress */
    const { playIcon, stopIcon, highlightDelay } = mdpVoicer;
    let { bgColor, iconColor } = mdpVoicer;

    function _selection() {

        const menu = {
            gspeak: true,
            disable: false
        };

        let text = '';
        let lang = '';
        let voice = '';

        /**
         * Mouse Up event handler
         */
        function onMouseUp () {

            setTimeout(function mouseTimeout() {

                if ( (0,_utils__WEBPACK_IMPORTED_MODULE_4__.hasTooltipDrawn)() ) {

                    if ( (0,_utils__WEBPACK_IMPORTED_MODULE_4__.hasSelection)() ) {

                        const voiceClass = (0,_utils__WEBPACK_IMPORTED_MODULE_4__.hasVoiceClass)();
                        lang = (0,_utils__WEBPACK_IMPORTED_MODULE_4__.getLangFromClass)( voiceClass );
                        voice = (0,_utils__WEBPACK_IMPORTED_MODULE_4__.getVoiceFromClass)( voiceClass );

                        /** Check is text will be prepared for Voicer or if blocked by voicer-off */
                        if ( (0,_utils__WEBPACK_IMPORTED_MODULE_4__.isSelectable)() ) {

                            selection = (0,_perfect_selection__WEBPACK_IMPORTED_MODULE_3__.snapSelectionToWord)();
                            text = (0,_perfect_selection__WEBPACK_IMPORTED_MODULE_3__.getHTMLOfSelection)();
                            (0,_tooltip_position__WEBPACK_IMPORTED_MODULE_2__.moveTooltip)();

                        } else {

                            removeVoicerButton();

                        }

                        /** If now playing, set icon to play. */
                        if ( document.querySelector('.mdp-voicer.stop') || document.querySelector('.mdp-voicer.loading') ) {

                            (0,_icons__WEBPACK_IMPORTED_MODULE_6__.setPlayIcon)(); //Set icon Play

                        }

                    } else {

                        /** Hide tooltip,  If we're now not paying. */
                        if ( ! document.querySelector('.mdp-voicer.stop') && ! document.querySelector('.mdp-voicer.loading') ) {

                            removeVoicerButton();

                        }

                    }

                } else if ( (0,_utils__WEBPACK_IMPORTED_MODULE_4__.hasSelection)() ) {

                    const voiceClass = (0,_utils__WEBPACK_IMPORTED_MODULE_4__.hasVoiceClass)();
                    lang = (0,_utils__WEBPACK_IMPORTED_MODULE_4__.getLangFromClass)( voiceClass );
                    voice = (0,_utils__WEBPACK_IMPORTED_MODULE_4__.getVoiceFromClass)( voiceClass );

                    selection = (0,_perfect_selection__WEBPACK_IMPORTED_MODULE_3__.snapSelectionToWord)();
                    text = voice.length > 0 ? (0,_perfect_selection__WEBPACK_IMPORTED_MODULE_3__.selectionExceptions)( (0,_perfect_selection__WEBPACK_IMPORTED_MODULE_3__.getHTMLOfSelection)() ) : (0,_perfect_selection__WEBPACK_IMPORTED_MODULE_3__.getHTMLOfSelection)();

                    /** Check is text will be prepared for Voicer or if blocked by voicer-off */
                    if ( (0,_utils__WEBPACK_IMPORTED_MODULE_4__.isSelectable)() ) {

                        drawTooltip();

                    }

                }

            }, 10);

        }

        /**
         * @returns {HTMLDivElement}
         */
        function gSpeakButton( uid ) {

            let AudioContext = window.AudioContext || window.webkitAudioContext || false;

            return new Button( playIcon, () => {

                /** Stop playing. */
                if ( document.querySelector( '.mdp-voicer.stop' ) ) {
                    (0,_audioContext__WEBPACK_IMPORTED_MODULE_0__.stopActiveSource)();
                    onVoiceEnded();
                    return;
                }

                /** Set 'loading' icon. */
                (0,_icons__WEBPACK_IMPORTED_MODULE_6__.setPreloaderIcon)( uid );

                /** AJAX Request with vanilla JS. */
                const { ajaxurl } = window.mdpVoicer;
                const request = new XMLHttpRequest();

                let args = (0,_query__WEBPACK_IMPORTED_MODULE_5__.getArgs)( uid, lang, voice, text );
                args.action = 'voicer_gspeak';

                request.open( 'POST', ajaxurl, true );
                request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
                request.onload = function () {

                    /** If successful. */
                    if ( this.status >= 200 && this.status < 400 ) {

                        if ( ! AudioContext ) {
                            console.error( 'Error of creating AudioContext.' );
                            return;
                        }

                        window.mdpVoicerContext.decodeAudioData( this.response, function( buffer ) {
                            const source = window.mdpVoicerContext.createBufferSource();
                            source.buffer = buffer;
                            (0,_audioContext__WEBPACK_IMPORTED_MODULE_0__.stopActiveSource)(); // Stop the active one if any.
                            window.voicerActiveSource = source;
                            source.connect( window.mdpVoicerContext.destination );
                            source.onended = onVoiceEnded;
                            source.start( 0 );

                            /** Set 'stop' icon. */
                            setStopIcon( uid );

                        }, function( e ){
                            console.error( 'Error of decoding audio data' + e.err );
                        });

                    } else {

                        console.warn( `Fail request: ${ this.response }` );

                    }

                };
                request.onerror = function() {

                    console.warn( 'Connection error.' );

                };
                request.responseType = 'arraybuffer';
                request.send( (0,_query__WEBPACK_IMPORTED_MODULE_5__.getQueryString)( args ) );

            } );

        }

        /** On Playback Finished */
        function onVoiceEnded() {

            /** Hide tooltip, if new selection wasn't made. */
            if ( document.querySelector( '.mdp-voicer.stop'  ) ) {
                removeVoicerButton();
            }

            /** Reload tooltip for highlighted tooltips */
            if ( document.querySelector( '.mdp-voicer-highlighted.stop'  ) ) {
                reloadVoicerButton();
            }

        }

        /** Remove voicer button */
        function removeVoicerButton() {

            const tooltips = document.querySelectorAll( '.mdp-voicer' );
            tooltips.forEach( $tooltip => {

                const uid = $tooltip.id.replace( 'mdp-voicer-', '' );

                $tooltip.remove();
                (0,_style__WEBPACK_IMPORTED_MODULE_1__.removeVoicerStyle)( uid );

            } );

        }

        /**
         * Reload voicer highlight button
         */
        function removeVoicerHighlightButton() {

            const tooltips = document.querySelectorAll( '.mdp-voicer-highlighted' );
            tooltips.forEach( $tooltip => {

                const uid = $tooltip.id.replace( 'mdp-voicer-', '' );

                $tooltip.remove();
                (0,_style__WEBPACK_IMPORTED_MODULE_1__.removeVoicerStyle)( uid );

            } );

        }

        /**
         * Reload voicer button
         */
        function reloadVoicerButton() {

            const tooltips = document.querySelectorAll( '.mdp-voicer-highlighted' );
            tooltips.forEach( $tooltip => {

                const uid = $tooltip.id.replace( 'mdp-voicer-', '' );

                let leftPosition = getComputedStyle( $tooltip ).left.replace( 'px', '');
                let topPosition = getComputedStyle( $tooltip ).top.replace( 'px', '');

                // Remove
                $tooltip.remove();
                (0,_style__WEBPACK_IMPORTED_MODULE_1__.removeVoicerStyle)( uid );

                // Reload
                drawTooltip( uid, leftPosition, topPosition );

            } );

        }

        /** Set Stop Icon. */
        function setStopIcon( uid ) {

            /** Select old icon that will be replaced. */
            const el = document.querySelector( `#mdp-voicer-${ uid } div.mdp-voicer-btn` );

            /** Create a new icon that will take the place of "el". */
            const newEl = document.createElement( 'div' );
            newEl.classList.add( 'mdp-voicer-btn' );
            newEl.innerHTML = stopIcon;

            /** Replace el with newEL. */
            el.parentNode.replaceChild( newEl, el );

            /** Mark tooltip as 'Stop' button. */
            const stop_popup = document.querySelector( `#mdp-voicer-${ uid }` );
            stop_popup.classList.remove( 'loading' );
            stop_popup.classList.add( 'stop' );

            /** Listen for stop click */
            stop_popup.addEventListener( 'click', ( e ) => {

                (0,_audioContext__WEBPACK_IMPORTED_MODULE_0__.stopActiveSource)();
                onVoiceEnded();

            } );

        }

        /**
         * Append icons
         * @returns {{length: number, icons: *}}
         */
        function appendIcons( uid ) {
            const myItems = [
                { feature: 'gspeak', call: gSpeakButton( uid ) }
            ];
            const div = document.createElement('div');
            let count = 0;
            myItems.forEach( function ( item) {
                if ( menu[item.feature] ) {
                    div.appendChild(item.call);
                    count++;
                }
            });
            return {
                icons: div,
                length: count
            };
        }

        /**
         * Render tooltip
         *
         * @param {string} uid
         * @param {string/boolean} leftPosition
         * @param {string/boolean} topPosition
         *
         */
        function drawTooltip( uid = '', leftPosition = false, topPosition = false ) {

            let AudioContext = window.AudioContext || window.webkitAudioContext || false;
            if ( ! window.mdpVoicerContext ) {
                window.mdpVoicerContext = new AudioContext();
            }

            _icons = appendIcons( uid );
            const tooltipPosition = (0,_tooltip_position__WEBPACK_IMPORTED_MODULE_2__.setTooltipPosition)( uid );
            left = leftPosition ? leftPosition : tooltipPosition.left;
            top = topPosition ? topPosition : tooltipPosition.top;

            (0,_style__WEBPACK_IMPORTED_MODULE_1__.addVoicerStyle)( uid );

            const div = document.createElement( 'div' );
            if ( isTouch ) {
                // div.style.transformOrigin = 'top';
                div.style.transform = 'scale( 1, -1 )';
            }

            div.id = `mdp-voicer-${ uid }`;
            div.className = uid === '' ? `mdp-voicer` : `mdp-voicer-highlighted`;
            div.appendChild( _icons.icons );

            document.body.appendChild( div );

            /** Dispatch event after tooltip drown */
            const eventDrawTooltip = new Event(
                'voicerDrawTooltip',
                {
                    detail: {
                        uid: uid,
                        left: left,
                        top: top,
                    }
                }
            );
            window.dispatchEvent( eventDrawTooltip );

        }

        /**
         * Attach necessary events
         */
        function attachEvents() {

            // Listen for selection
            window.addEventListener( 'mouseup', onMouseUp, true );
            window.addEventListener( 'touchend', onMouseUp, false );
            window.addEventListener( 'touchcancel', onMouseUp, false );
            window.addEventListener( 'selectionchange', onMouseUp, false );

            // Listen for resize
            window.addEventListener( 'resize', _tooltip_position__WEBPACK_IMPORTED_MODULE_2__.moveTooltip, false );

            /** We want to detect human touch, not device touch. */
            window.addEventListener( 'touchstart', function onFirstTouch() {

                isTouch = true; //Set global flag
                document.addEventListener( 'selectionchange', onMouseUp, true );

                /** We only need to know once that a human touched the screen, so we can stop listening now. */
                window.removeEventListener( 'touchstart', onFirstTouch, false );

            } );

        }

        /**
         * Attach highlights
         */
        function attachHighlights() {

            // Find highlighted texts
            const highlights = document.querySelectorAll( '.voicer-highlight' );

            // Highlight
            highlights.forEach( $highlighted  => {

                // Get text from shortcode
                text = $highlighted.innerHTML;
                const uid = $highlighted.id.replace( 'voicer-highlight-', '' );

                drawTooltip( uid );

            } );

        }

        /**
         * Voicer config
         * @param options
         * @return {config}
         */
        function config( options ) {

            menu.gspeak = options.gspeak === undefined ? menu.gspeak : options.gspeak;
            menu.disable = options.disable === undefined ? menu.disable : options.disable;

            bgColor = options.backgroundColor || '#333';
            iconColor = options.iconColor || '#fff';
            return this;

        }

        /**
         * Init Voicer
         * @return {init}
         */
        function init() {

            attachEvents();
            (0,_utils__WEBPACK_IMPORTED_MODULE_4__.fixHighlights)();

            setTimeout( attachHighlights, parseInt( highlightDelay ) * 1000 );

            return this;

        }

        return {
            config: config,
            init: init,
            draw: drawTooltip,
            reload: reloadVoicerButton,
            remove: removeVoicerHighlightButton
        };

    }

    /**
     * Render button.
     * @param icon - SVG icon
     * @param clickFn - Click event handler
     * @return {HTMLDivElement}
     * @constructor
     */
    function Button( icon, clickFn ) {

        const btn = document.createElement('div');
        btn.classList.add( 'mdp-voicer-btn' );

        btn.innerHTML = icon;
        btn.onclick = clickFn;
        btn.ontouchstart = clickFn; // For iPhones

        if ( btn.id === 'mdp-voicer-preloader' ) {
            btn.style.transition = 'none';
        }

        else {
            btn.onmouseover = function () {
                this.style.transform = 'scale(1.2)';
            };
            btn.onmouseout = function () {
                this.style.transform = 'scale(1)';
            };
        }

        return btn;
    }

    return _selection;

})();


/***/ }),

/***/ "./wp-content/plugins/voicer/source/js/import/_tooltip-position.js":
/*!*************************************************************************!*\
  !*** ./wp-content/plugins/voicer/source/js/import/_tooltip-position.js ***!
  \*************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   moveTooltip: () => (/* binding */ moveTooltip),
/* harmony export */   setTooltipPosition: () => (/* binding */ setTooltipPosition)
/* harmony export */ });
/* harmony import */ var _textSelection__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./_textSelection */ "./wp-content/plugins/voicer/source/js/import/_textSelection.js");


const { iconSize, iconMargin, arrowSize } = window.mdpVoicer;

/**
 * Calculate tooltip position
 */
function setTooltipPosition( uid = '' ) {

    const $content = document.querySelector( `#voicer-highlight-${ uid }` )
    if ( $content === null && _textSelection__WEBPACK_IMPORTED_MODULE_0__.selection === '' ) {

        return {
            'left': -1000,
            'top': -1000
        };

    }

    const position = $content ?
        $content.getBoundingClientRect():
        _textSelection__WEBPACK_IMPORTED_MODULE_0__.selection.getRangeAt( 0 ).getBoundingClientRect();

    const docScrollTop = window.scrollX || document.documentElement.scrollTop || document.body.scrollTop;

    let buttonSize = parseInt( iconSize ) + parseInt( iconMargin ) * 2;
    let left, top;

    if ( $content ) {

        // Get position
        const shortcodePosition = $content.getAttribute( 'data-position' );
        const textHeight = position.bottom - position.top;

        // Set position
        switch ( shortcodePosition ) {

            case 'top-left':
                left    = position.left - buttonSize / 2;
                top     = ! _textSelection__WEBPACK_IMPORTED_MODULE_0__.isTouch ? position.top + docScrollTop - buttonSize - arrowSize : position.bottom + docScrollTop + buttonSize + arrowSize;
                break;

            case 'top-center':
                left    = position.left + ( position.width - buttonSize * _textSelection__WEBPACK_IMPORTED_MODULE_0__._icons.length ) / 2;
                top     = ! _textSelection__WEBPACK_IMPORTED_MODULE_0__.isTouch ? position.top + docScrollTop - buttonSize - arrowSize : position.bottom + docScrollTop + buttonSize + arrowSize;
                break;

            case 'top-right':
                left    = position.right - buttonSize / 2;
                top     = ! _textSelection__WEBPACK_IMPORTED_MODULE_0__.isTouch ? position.top + docScrollTop - buttonSize - arrowSize : position.bottom + docScrollTop + buttonSize + arrowSize;
                break;

            case 'left-top':
                left    = position.left - buttonSize - arrowSize;
                top     = position.top + docScrollTop - textHeight;
                break;

            case 'left-center':
                left    = position.left - buttonSize - arrowSize;
                top     = position.top + docScrollTop - ( textHeight / 2 );
                break;

            case 'left-bottom':
                left    = position.left - buttonSize - arrowSize;
                top     = position.top + docScrollTop;
                break;

            case 'right-top':
                left    = position.right + arrowSize;
                top     = position.top + docScrollTop - textHeight;
                break;

            case 'right-center':
                left    = position.right + arrowSize;
                top     = position.top + docScrollTop - ( textHeight / 2 );
                break;

            case 'right-bottom':
                left    = position.right + arrowSize;
                top     = position.top + docScrollTop;
                break;

            case 'bottom-left':
                left    = position.left - buttonSize / 2;
                top     = position.top + textHeight + arrowSize;
                break;

            case 'bottom-center':
                left    = position.left + ( position.width - buttonSize * _textSelection__WEBPACK_IMPORTED_MODULE_0__._icons.length ) / 2;
                top     = position.top + textHeight + arrowSize;
                break;

            case 'bottom-right':
                left    = position.right - buttonSize / 2;
                top     = position.top + textHeight + arrowSize;
                break;

            default: // Top Center by default
                left = position.left + ( position.width - buttonSize * _textSelection__WEBPACK_IMPORTED_MODULE_0__._icons.length ) / 2;
                top = ! _textSelection__WEBPACK_IMPORTED_MODULE_0__.isTouch ? position.top + docScrollTop - buttonSize - arrowSize : position.bottom + docScrollTop + buttonSize + arrowSize;
                break;

        }

    } else {

        left = position.left + ( position.width - buttonSize * _textSelection__WEBPACK_IMPORTED_MODULE_0__._icons.length ) / 2;
        top = ! _textSelection__WEBPACK_IMPORTED_MODULE_0__.isTouch ? position.top + docScrollTop - buttonSize - arrowSize : position.bottom + docScrollTop + buttonSize + arrowSize;

    }

    return {
        'left': left,
        'top': top
    };

}

/**
 * Move tooltip
 */
function moveTooltip() {

    const mdpVoicer = document.querySelectorAll( '.mdp-voicer' );
    const mdpVoicerHighlighted = document.querySelectorAll( '.mdp-voicer-highlighted' );

    // Mover regular tooltips
    mdpVoicer.forEach( $tooltip => {

        const uid = $tooltip.id.replace( 'mdp-voicer-', '' );

        const tooltipPosition = setTooltipPosition( uid );
        $tooltip.style.top = tooltipPosition.top + 'px';
        $tooltip.style.left = tooltipPosition.left + 'px';

    } );

    // Move highlight tooltip
    mdpVoicerHighlighted.forEach( $tooltip => {

        const uid = $tooltip.id.replace( 'mdp-voicer-', '' );

        const tooltipPosition = setTooltipPosition( uid );
        $tooltip.style.top = tooltipPosition.top + 'px';
        $tooltip.style.left = tooltipPosition.left + 'px';

    } );

}


/***/ }),

/***/ "./wp-content/plugins/voicer/source/js/import/_utils.js":
/*!**************************************************************!*\
  !*** ./wp-content/plugins/voicer/source/js/import/_utils.js ***!
  \**************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   fixHighlights: () => (/* binding */ fixHighlights),
/* harmony export */   getLangFromClass: () => (/* binding */ getLangFromClass),
/* harmony export */   getVoiceFromClass: () => (/* binding */ getVoiceFromClass),
/* harmony export */   getVoiceFromHighlight: () => (/* binding */ getVoiceFromHighlight),
/* harmony export */   hasOffClass: () => (/* binding */ hasOffClass),
/* harmony export */   hasSelection: () => (/* binding */ hasSelection),
/* harmony export */   hasTooltipDrawn: () => (/* binding */ hasTooltipDrawn),
/* harmony export */   hasVoiceClass: () => (/* binding */ hasVoiceClass),
/* harmony export */   isSelectable: () => (/* binding */ isSelectable)
/* harmony export */ });
const { use, highlightPosition } = window.mdpVoicer;

/**
 * Check is something selected on the page
 * @return {boolean}
 */
function hasSelection() {

    return !!window.getSelection().toString();

}

/**
 * Check is voicer tooltip already exist on the page
 * @return {boolean}
 */
function hasTooltipDrawn() {

    return !!document.querySelector( '.mdp-voicer' );

}

/**
 * Get voice slug for selection or return false
 * @returns {*|string}
 */
function hasVoiceClass() {

    const selection = window.getSelection();
    const startNode = selection.anchorNode.parentElement;
    const endNode = selection.focusNode.parentElement;

    const startVoice = checkParentsClass( startNode, /voicer-voice+\S*\w/ );
    if ( startVoice.length > 0 )
        return startVoice;

    const endVoice = checkParentsClass( endNode, /voicer-voice+\S*\w/ );
    if ( endVoice.length > 0 )
        return endVoice;

    return false;

}

/**
 * Check is doom contains voicer-off class
 * @returns {boolean}
 */
function hasOffClass() {

    return document.querySelectorAll( '.voicer-off' ).length > 0;

}

/**
 * Check is selection can be selected for voicer or ib blocked by voicer-off
 * @returns {boolean|boolean}
 */
function isSelectable() {

    return hasOffClass() || ! JSON.parse( use ) ? voice.length > 0 : true;

}

/**
 * Find class by regex in parent elements
 * @param node
 * @param regex
 * @returns {string}
 */
function checkParentsClass( node, regex ) {

    while ( node != null ) {

        const { className } = node;

        if ( className && className.split( ' ' ).some( ( c ) => { return regex.test( c ) } ) ) {

            return className.match( regex );

        }

        node = node.parentNode;

    }

    return '';

}

function checkChildrenClass( node, regex ) {

    const children = node.children;

    for ( let i = 0; i < children.length; i++ ) {

        const { className } = children[ i ];

        if ( className && className.split( ' ' ).some( ( c ) => { return regex.test( c ) } ) ) {

            return className.match( regex );

        }

    }

    return '';

}

/**
 * Returns voice from voicer voice css class
 * @param classString
 * @returns {*|string}
 */
function getVoiceFromClass( classString ) {

    return ( typeof classString === 'object' ) ? classString[ 0 ].replace( 'voicer-voice-', '' ) : '';

}

/**
 * Returns voice from highlight
 * @param $el
 * @returns {boolean}
 */
function getVoiceFromHighlight( $el ) {

    let voice = '';

    // Find in parent
    $el.classList.forEach( ( className ) => {

        if ( className.includes( 'voicer-voice-' ) ) {
            voice = className.replace( 'voicer-voice-', '' );
        }

    } );

    // Find in children
    if ( checkChildrenClass( $el, /voicer-voice+\S*\w/ ).length > 0 ) {

        voice = checkChildrenClass( $el, /voicer-voice+\S*\w/ )[0].replace( 'voicer-voice-', '' );

    }

    return voice;

}

/**
 * Returns lang code from voice css class
 * @param classString
 * @returns {string|string}
 */
function getLangFromClass( classString ) {

    classString = getVoiceFromClass( classString );

    return classString.length > 0 ? classString.split( '-', 2 ).join( '-' ) : '';

}

/**
 * Add necessary id and data-attributes to highlights which init by CSS class
 */
function fixHighlights() {

    const highlights = document.querySelectorAll( '.voicer-highlight' );

    // Highlight
    highlights.forEach( $highlighted  => {

        // Add id if not exist
        if ( ! $highlighted.id ) {
            $highlighted.id = 'voicer-highlight-' + Math.random().toString( 36 ).substr( 2, 9 );
        }

        if ( ! $highlighted.getAttribute( 'data-position' ) ) {
            $highlighted.setAttribute( 'data-position', highlightPosition );
        }

    } );

}


/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
/*!*******************************************************!*\
  !*** ./wp-content/plugins/voicer/source/js/voicer.js ***!
  \*******************************************************/
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _import_init__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./import/_init */ "./wp-content/plugins/voicer/source/js/import/_init.js");
/**
 * Voicer
 * Voicer converts text into human-like speech in more than 295 voices across 50+ languages and variants.
 * Exclusively on https://1.envato.market/voicer
 *
 * @encoding        UTF-8
 * @version         3.2.3
 * @copyright       (C) 2018 - 2022 Merkulove ( https://merkulov.design/ ). All rights reserved.
 * @license         Envato License https://1.envato.market/KYbje
 * @contributors    Nemirovskiy Vitaliy (nemirovskiyvitaliy@gmail.com), Dmitry Merkulov (dmitry@merkulov.design)
 * @support         help@merkulov.design
 **/



document.readyState === 'loading' ?
    document.addEventListener( 'DOMContentLoaded', _import_init__WEBPACK_IMPORTED_MODULE_0__.loadVoicer ) :
    (0,_import_init__WEBPACK_IMPORTED_MODULE_0__.loadVoicer)();


})();

/******/ })()
;